package fr.univlehavre.entree;

import java.util.Arrays;

public class Personne implements Entree {
	private String nom;
	private String[] prenoms;
	private Genre genre;
	private Personne conjoint;
	private Societe societe;
	private String fonction;

	public Personne(String nom, String[] prenoms, Genre genre, Personne conjoint, Societe societe, String fonction) {
		this.nom = nom;
		this.prenoms = prenoms;
		this.genre = genre;
		this.conjoint = conjoint;
		this.societe = societe;
		this.fonction = fonction;
	}

	public String getNom() {
		return nom;
	}

	public String[] getPrenoms() {
		return prenoms;
	}

	public Genre getGenre() {
		return genre;
	}

	public Personne getConjoint() {
		return conjoint;
	}

	public Societe getSociete() {
		return societe;
	}

	public String getFonction() {
		return fonction;
	}

	@Override
	public String toString(Presentation presentation, Sens sens) {
		String result = null;
		switch (presentation) {
			case COMPLET:
				result = String.format(this.formatGenre() + "\n" + "-Société: " + this.societe + "\n" + "-Fonction: " + this.fonction);
				break;
			case ABREGE:
				result = sens == Sens.NOM_PRENOMS ? this.nom + " " + initiales(this.prenoms) : initiales(this.prenoms) + " " + this.nom;
				break;
			case SIMPLE:
				int len = this.prenoms.length;
				String[] prenoms = Arrays.copyOfRange(this.prenoms, 1, len - 1);
				result = this.formatGenre() + " " + initiales(prenoms) + " (" + this.societe.getRaisonSociale() + ")";
				break;
		}
		return result;
	}

	@Override
	public Boolean recherche(String text) {
		return null;
	}

	private String initiales(String[] prenoms) {
		String result = "";
		for (String prenom : prenoms) {
			result.concat(prenom + ". ");
		}
		return result;
	}

	private String formatGenre() {
		String genre = null;
		switch (this.genre) {
			case HOMME:
				genre = "M.";
				break;
			case FEMME:
				genre = "Mme";
				break;
		}
		return genre;
	}

}
